import chalk from "chalk";
import { createRequire } from "node:module";
const require = createRequire(import.meta.url);
const cliui = require("cliui");
const maxLengthLastPublish = 20;
export default class UITable {
    constructor(options) {
        this._ui = cliui({});
        this._depsMaxLength =
            options.depsMaxLength === 0 ? 6 : options.depsMaxLength;
        this._name = options.name ?? "unknown";
        this._path = options.path;
        this._ui.div({
            padding: [1, 1, 0, 1],
            text: chalk.cyan.bold(`Report for ${this._name} (${this._path})`),
        });
        this._ui.div(this.toRowColumn(chalk.bold("Name"), this._depsMaxLength), this.toRowColumn(chalk.bold("Last Publish"), maxLengthLastPublish));
    }
    toRowColumn(text, width) {
        return {
            padding: [0, 1, 0, 1],
            text,
            ...(width && { width: width + 2 }),
        };
    }
    addRow(dep, lastUpdate) {
        this._ui.div(this.toRowColumn(dep, this._depsMaxLength), this.toRowColumn(lastUpdate, maxLengthLastPublish));
    }
    resetOutput() {
        return this._ui.resetOutput();
    }
    toString() {
        return this._ui.toString();
    }
}
